"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _modal = require("antd-mobile/lib/modal");

var _modal2 = _interopRequireDefault(_modal);

var _actionSheet = require("antd-mobile/lib/action-sheet");

var _actionSheet2 = _interopRequireDefault(_actionSheet);

var _toConsumableArray2 = require("babel-runtime/helpers/toConsumableArray");

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

require("antd-mobile/lib/modal/style/css");

require("antd-mobile/lib/action-sheet/style/css");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactImages = require("react-images");

var _reactImages2 = _interopRequireDefault(_reactImages);

var _Album = require("./Album/Album");

var _Album2 = _interopRequireDefault(_Album);

var _AttUtil = require("./AttUtil/AttUtil");

var _AttUtil2 = _interopRequireDefault(_AttUtil);

var _Camera = require("./Camera/Camera");

var _Camera2 = _interopRequireDefault(_Camera);

var _Video = require("./Video/Video");

var _Video2 = _interopRequireDefault(_Video);

var _Audio = require("./Audio/Audio");

var _Audio2 = _interopRequireDefault(_Audio);

require("./Attachments.scss");

var _icon = require("./images/icon");

var _Sign = require("./Sign/Sign");

var _Sign2 = _interopRequireDefault(_Sign);

var _SignCanvas = require("./Sign/SignCanvas");

var _SignCanvas2 = _interopRequireDefault(_SignCanvas);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ListView = require("../ListView");

var _ListView2 = _interopRequireDefault(_ListView);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Attachments = function (_Component) {
  (0, _inherits3.default)(Attachments, _Component);

  function Attachments() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, Attachments);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = Attachments.__proto__ || Object.getPrototypeOf(Attachments)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      isOpen: false,
      currentImage: 0,
      pic: [],
      video: '',
      videoPath: '',
      audio: '',
      audioPath: '',
      isSigning: false,
      sign: '',
      star: 0
    }, _this.getPic = function (picData) {
      var pic = _this.state.pic;

      var newPic = [].concat((0, _toConsumableArray3.default)(pic));
      newPic.push(picData);
      _this.setState({
        pic: newPic
      });
    }, _this.getVideo = function (videoData, videoPath) {
      _this.setState({
        video: videoData,
        videoPath: videoPath
      });
    }, _this.getAudio = function (audioData, audioPath) {
      _this.setState({
        audio: audioData,
        audioPath: audioPath
      });
    }, _this.getSign = function (isSigning, signData, starData) {
      _this.setState({
        isSigning: isSigning
      });
      if (signData) {
        _this.setState({
          sign: signData
        });
      }
      if (starData) {
        _this.setState({
          star: starData
        });
      }
    }, _this.getCanvas = function () {
      _this.setState({
        isSigning: true
      });
    }, _this.showMoreSheet = function () {
      var _this$props = _this.props,
          useVideo = _this$props.useVideo,
          useAudio = _this$props.useAudio,
          useSign = _this$props.useSign,
          more = _this$props.more;

      var moreList = [];
      useVideo ? moreList.push({ icon: _react2.default.createElement(_Video2.default, { onClick: _this.getVideo }), title: '视频' }) : '';
      useAudio ? moreList.push({ icon: _react2.default.createElement(_Audio2.default, { onClick: _this.getAudio }), title: '录音' }) : '';
      useSign ? moreList.push({ icon: _react2.default.createElement(_Sign2.default, { onClick: _this.getCanvas }), title: '签字' }) : '';
      if (_AttUtil2.default.isFilledArray(more)) {
        more.map(function (item) {
          moreList.push(item);
        });
      }
      _actionSheet2.default.showShareActionSheetWithOptions({
        options: moreList
      });
    }, _this.showPrePicNode = function () {
      var _this$state = _this.state,
          pic = _this$state.pic,
          currentImage = _this$state.currentImage,
          isOpen = _this$state.isOpen;

      var gotoPrevious = function gotoPrevious() {
        _this.setState({
          currentImage: _this.state.currentImage - 1
        });
      };
      var gotoNext = function gotoNext() {
        _this.setState({
          currentImage: _this.state.currentImage + 1
        });
      };
      var closeLightbox = function closeLightbox() {
        _this.setState({
          isOpen: false
        });
      };
      var prePic = pic.map(function (item) {
        return { src: _AttUtil2.default.PIC_PREFIX + item };
      });
      return _react2.default.createElement(_reactImages2.default, {
        images: prePic,
        currentImage: currentImage,
        isOpen: isOpen,
        onClickPrev: function onClickPrev() {
          return gotoPrevious();
        },
        onClickNext: function onClickNext() {
          return gotoNext();
        },
        onClose: function onClose() {
          return closeLightbox();
        }
      });
    }, _this.showPicNode = function () {
      var pic = _this.state.pic;
      var _this$props2 = _this.props,
          isModify = _this$props2.isModify,
          pictures = _this$props2.pictures;

      var canDelete = !pictures || isModify;
      //删除图片
      var deletePic = function deletePic(index) {
        var newPic = [].concat((0, _toConsumableArray3.default)(pic));
        newPic.splice(index, 1);
        _this.setState({
          pic: newPic
        });
      };
      //打开图片预览图
      var openPreviewPic = function openPreviewPic(index) {
        var isOpen = _this.state.isOpen;

        _this.setState({
          isOpen: !isOpen,
          currentImage: index
        });
      };
      var src = [];
      return pic.map(function (data, index) {
        src.push({ src: _AttUtil2.default.isBase64Data(data) ? _AttUtil2.default.PIC_PREFIX + data : data });
        return _react2.default.createElement(
          "div",
          { className: "zk_attachments_pic", key: 'pic-' + index },
          _react2.default.createElement("img", { src: _AttUtil2.default.PIC_PREFIX + data, onClick: function onClick() {
              openPreviewPic(index);
            }, alt: 'pic' }),
          canDelete ? _react2.default.createElement("a", { className: "zk_attachments_del", onClick: function onClick() {
              deletePic(index);
            } }) : ''
        );
      });
    }, _this.showVideoNode = function () {
      var _this$state2 = _this.state,
          videoPath = _this$state2.videoPath,
          video = _this$state2.video;
      var _this$props3 = _this.props,
          isModify = _this$props3.isModify,
          videos = _this$props3.videos;

      var canDelete = !_AttUtil2.default.isFilledArray(videos) || isModify;
      var deleteVideo = function deleteVideo() {
        _this.setState({
          video: '',
          videoPath: ''
        });
      };
      var src = videoPath ? videoPath : _AttUtil2.default.VIDEO_PREFIX + video;
      return video || videoPath ? _react2.default.createElement(
        "div",
        { className: "zk_attachments_video" },
        _react2.default.createElement("video", { src: src, controls: true, preload: "auto" }),
        canDelete ? _react2.default.createElement("a", { className: "zk_attachments_del", onClick: function onClick() {
            deleteVideo();
          } }) : ''
      ) : '';
    }, _this.showAudioNode = function () {
      var _this$state3 = _this.state,
          audioPath = _this$state3.audioPath,
          audio = _this$state3.audio,
          isPlay = _this$state3.isPlay;
      var _this$props4 = _this.props,
          isModify = _this$props4.isModify,
          audios = _this$props4.audios;

      var canDelete = !_AttUtil2.default.isFilledArray(audios) || isModify;
      var playAudio = function playAudio() {
        var media = new Media(audioPath, function () {}, function (e) {
          console.log('获取音频失败', e);
          _this.setState({
            isPlay: false
          });
        }, function (mediaStatus) {
          if (mediaStatus === _AttUtil2.default.MEDIA_RUNNING) {
            _this.setState({
              isPlay: true
            });
          } else if (mediaStatus === _AttUtil2.default.MEDIA_PAUSED || mediaStatus === _AttUtil2.default.MEDIA_STOPPED) {
            _this.setState({
              isPlay: false
            });
          }
        });
        isPlay ? media.pause() : media.play();
      };
      var deleteAudio = function deleteAudio() {
        _modal2.default.alert('', '确定要删除音频?', [{ text: '取消' }, {
          text: '确定', onPress: function onPress() {
            _this.setState({
              audio: '',
              audioPath: ''
            });
          }
        }]);
      };
      return audio || audioPath ? _react2.default.createElement(
        "div",
        { className: 'zk_attachments_audio',
          onClick: function onClick() {
            playAudio();
          } },
        _react2.default.createElement("img", { className: 'zk_attachments_audio_flag', src: _icon.audioFlagIcon, alt: 'flag' }),
        _react2.default.createElement("img", { className: 'zk_attachments_audio_play', src: isPlay ? _icon.audioPauseIcon : _icon.audioPlayIcon, alt: 'play' }),
        canDelete ? _react2.default.createElement("a", { className: 'zk_attachments_del', onClick: function onClick(e) {
            e.stopPropagation();
            deleteAudio();
          } }) : ''
      ) : '';
    }, _this.showSignNode = function () {
      var sign = _this.state.sign;
      var _this$props5 = _this.props,
          signs = _this$props5.signs,
          isModify = _this$props5.isModify;

      var canDelete = !signs || isModify;
      var deleteSign = function deleteSign() {
        _this.setState({
          sign: '',
          star: 0
        });
      };
      return sign ? _react2.default.createElement(
        "div",
        { className: "zk_attachments_pic" },
        _react2.default.createElement("img", { src: _AttUtil2.default.PIC_PREFIX + sign, onClick: function onClick() {
            _this.getCanvas();
          }, alt: 'sign' }),
        canDelete ? _react2.default.createElement("a", { className: "zk_attachments_del", onClick: function onClick() {
            deleteSign();
          } }) : ''
      ) : '';
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(Attachments, [{
    key: "componentWillMount",
    value: function componentWillMount() {
      var _props = this.props,
          pictures = _props.pictures,
          videos = _props.videos,
          audios = _props.audios,
          signs = _props.signs,
          stars = _props.stars;

      if (pictures && pictures.length) {
        this.setState({
          pic: pictures
        });
      }
      if (_AttUtil2.default.isFilledArray(videos)) {
        if (_AttUtil2.default.isBase64Data(videos[0])) {
          this.setState({
            video: videos[0]
          });
        } else {
          this.setState({
            videoPath: videos[0]
          });
        }
      }
      if (_AttUtil2.default.isFilledArray(audios)) {
        if (_AttUtil2.default.isBase64Data(audios[0])) {
          this.setState({
            audio: audios[0]
          });
        } else {
          this.setState({
            audioPath: audios[0]
          });
        }
      }
      if (signs) {
        this.setState({
          sign: signs
        });
      }
      if (stars) {
        this.setState({
          star: stars
        });
      }
    }

    //获取图片


    //获取录像


    //获取录像


    //获取签字


    //获取画布


    //显示更多sheet


    //预览图展示区


    //图片展示区


    //录像展示区


    //录音展示区


    //签字展示区

  }, {
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps, prevState, snapshot) {
      var _state = this.state,
          pic = _state.pic,
          video = _state.video,
          videoPath = _state.videoPath,
          audio = _state.audio,
          audioPath = _state.audioPath,
          sign = _state.sign,
          star = _state.star;

      var hasNewPic = prevState.pic.length !== pic.length;
      var hasNewVideo = prevState.video !== video || prevState.videoPath !== videoPath;
      var hasNewAudio = prevState.audio !== audio || prevState.audioPath !== audioPath;
      var hasNewSign = prevState.sign !== sign || prevState.star !== star;
      if (hasNewPic || hasNewVideo || hasNewAudio || hasNewSign) {
        var onChange = this.props.onChange;

        var attachments = {
          pictures: pic,
          videos: video,
          videoPaths: videoPath,
          audios: audio,
          audioPaths: audioPath,
          signs: sign,
          stars: star
        };
        onChange ? onChange(attachments) : '';
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this2 = this;

      var _state2 = this.state,
          pic = _state2.pic,
          video = _state2.video,
          videoPath = _state2.videoPath,
          audio = _state2.audio,
          audioPath = _state2.audioPath,
          isSigning = _state2.isSigning,
          sign = _state2.sign;
      var _props2 = this.props,
          useCamera = _props2.useCamera,
          useAlbum = _props2.useAlbum,
          useVideo = _props2.useVideo,
          more = _props2.more,
          useAudio = _props2.useAudio,
          picMaxNum = _props2.picMaxNum,
          useStar = _props2.useStar,
          stars = _props2.stars,
          signs = _props2.signs;

      var hasAttachment = _AttUtil2.default.isFilledArray(pic) || video || videoPath || audio || audioPath || sign;
      var hasMore = useAudio || useVideo || more;
      return _react2.default.createElement(
        "div",
        null,
        this.showPrePicNode(),
        _react2.default.createElement(_SignCanvas2.default, { useStar: useStar, isSigning: isSigning, onChange: this.getSign, stars: stars, signs: signs }),
        _react2.default.createElement(
          "div",
          { className: hasAttachment ? 'zk_attachments_area' : '' },
          this.showVideoNode(),
          this.showPicNode(),
          this.showAudioNode(),
          this.showSignNode()
        ),
        _react2.default.createElement(
          "div",
          { className: 'zk_attachments_btn' },
          useAlbum ? _react2.default.createElement(_Album2.default, { onClick: this.getPic, picNum: pic.length, picMaxNum: picMaxNum }) : '',
          useCamera ? _react2.default.createElement(_Camera2.default, { onClick: this.getPic, picNum: pic.length, picMaxNum: picMaxNum }) : '',
          hasMore ? _react2.default.createElement("img", { className: 'zk_attachments_more', onClick: function onClick() {
              _this2.showMoreSheet();
            }, src: _icon.moreIcon, alt: '更多' }) : ''
        )
      );
    }
  }]);
  return Attachments;
}(_react.Component);

Attachments.propTypes = {
  // 使用拍摄功能
  useCamera: _propTypes2.default.bool,
  // 使用相册功能
  useAlbum: _propTypes2.default.bool,
  // 使用录像功能
  useVideo: _propTypes2.default.bool,
  // 使用录音功能
  useAudio: _propTypes2.default.bool,
  // 使用签字功能
  useSign: _propTypes2.default.bool,
  // 使用客户评价功能（在useSign为true时生效）
  useStar: _propTypes2.default.bool,
  // 扩展其他类型附件时使用，传入一个元素为img标签的数组，该数组中的img会被放入更多按钮的sheet中
  more: _propTypes2.default.array,
  // 图片展示（支持base64码或图片路径）
  pictures: _propTypes2.default.array,
  // 视频展示（支持base64码或视频路径）
  videos: _propTypes2.default.array,
  // 音频展示（支持音频路径）
  audios: _propTypes2.default.array,
  // 签字展示（支持base64码或图片路径）
  signs: _propTypes2.default.array,
  // 返回所有附件数据的回调，获取组件内数据
  onChange: _propTypes2.default.func,
  //是否可以修改照片（用于既提供图片又可拍照的场景）
  isModify: _propTypes2.default.bool
};

exports.default = Attachments;
//# sourceMappingURL=Attachments.js.map