'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _echartsForReact = require('echarts-for-react');

var _echartsForReact2 = _interopRequireDefault(_echartsForReact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Line = function (_Component) {
  (0, _inherits3.default)(Line, _Component);

  function Line(props) {
    (0, _classCallCheck3.default)(this, Line);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Line.__proto__ || Object.getPrototypeOf(Line)).call(this, props));

    _this.loading = null;
    _this.time = 3000;
    _this.textColor = '#2983c7';

    _this.onChartReady = function (chart) {
      _this.loading = setTimeout(function () {
        chart.hideLoading();
      }, _this.time);
      console.log('echarts is ready');
    };

    _this.getOption = function () {
      return {
        title: {
          text: _this.props.title,
          x: 'center',
          textStyle: {
            color: _this.textColor,
            fontWeight: 'normal'
          }
        },
        tooltip: {
          trigger: 'axis'
        },
        legend: {
          data: _this.props.lineDataArr.map(function (item) {
            return item.name;
          }),
          bottom: 0,
          right: 'auto'
        },
        grid: {
          left: '3%',
          right: '4%',
          top: '14%',
          containLabel: true
        },
        xAxis: [{
          type: 'category',
          boundaryGap: false,
          data: _this.props.xDataArr,
          show: _this.props.xDataArr.length > 0
        }],
        yAxis: [{
          type: 'value',
          show: _this.props.xDataArr.length > 0
        }],
        series: _this.seriesData(_this.props.lineDataArr)
      };
    };

    _this.getLoadingOption = function () {
      return {
        text: '加载中...',
        color: '#000',
        textColor: '#000',
        maskColor: '#fff'
      };
    };

    _this.handleData = function (data) {
      var body = '';
      if (data.length === 0) {
        body = _react2.default.createElement(
          'div',
          { className: 'zk_div-echars_nodata', style: { display: _this.state.display } },
          '\u65E0\u6570\u636E'
        );
      }
      return body;
    };

    _this.seriesData = function (lineDataArr) {
      var seriesArr = [];
      for (var i = 0; i < lineDataArr.length; i++) {
        var seriesArrItem = {
          name: lineDataArr[i].name,
          type: 'line',
          stack: _this.props.stack ? '总量' : '',
          data: lineDataArr[i].data,
          areaStyle: _this.props.stack ? {} : null
        };
        seriesArr.push(seriesArrItem);
      }
      return seriesArr;
    };

    _this.state = {
      showLoading: true
    };
    return _this;
  }

  (0, _createClass3.default)(Line, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.loading);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.onChartReady(this.echarts_react.getEchartsInstance());
      this.setState({
        display: 'block',
        showLoading: false
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var xDataArr = this.props.xDataArr;

      var body = this.handleData(xDataArr);
      return _react2.default.createElement(
        'div',
        { style: { position: 'relative' } },
        _react2.default.createElement(_echartsForReact2.default, {
          ref: function ref(e) {
            _this2.echarts_react = e;
          },
          option: this.getOption(),
          loadingOption: this.getLoadingOption(),
          onChartReady: this.onChartReady,
          showLoading: this.state.showLoading,
          className: this.props.className
        }),
        body
      );
    }
  }]);
  return Line;
}(_react.Component); /**
                      * 折线图组件
                      */


Line.propTypes = {
  // 数据
  xDataArr: _propTypes2.default.array.isRequired,
  lineDataArr: _propTypes2.default.array.isRequired,
  // 标题
  title: _propTypes2.default.string,
  // 是否是堆叠效果
  stack: _propTypes2.default.bool,
  // 容器样式类
  className: _propTypes2.default.string
};
exports.default = Line;
//# sourceMappingURL=Line.js.map