'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _navBar = require('antd-mobile/lib/nav-bar');

var _navBar2 = _interopRequireDefault(_navBar);

var _icon = require('antd-mobile/lib/icon');

var _icon2 = _interopRequireDefault(_icon);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

require('antd-mobile/lib/nav-bar/style/css');

require('antd-mobile/lib/icon/style/css');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRouter = require('react-router');

require('./styles/Page.scss');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 页面头部导航栏
 */
/**
 * 页面容器组件，页头、身体、页脚三部分组成
 */
var PageHead = function (_Component) {
  (0, _inherits3.default)(PageHead, _Component);

  function PageHead() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3.default)(this, PageHead);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3.default)(this, (_ref = PageHead.__proto__ || Object.getPrototypeOf(PageHead)).call.apply(_ref, [this].concat(args))), _this), _this.back = function () {
      var _this$props = _this.props,
          backLevel = _this$props.backLevel,
          isIndex = _this$props.isIndex,
          router = _this$props.router;

      if (isIndex) {
        return;
      }
      if (backLevel) {
        router.go(-1 * backLevel);
      } else {
        router.goBack();
      }
    }, _this.onLeftClick = function () {
      var beforeBack = _this.props.beforeBack;

      if (beforeBack) {
        beforeBack(_this.back);
      } else {
        _this.back();
      }
    }, _temp), (0, _possibleConstructorReturn3.default)(_this, _ret);
  }

  (0, _createClass3.default)(PageHead, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          title = _props.title,
          isIndex = _props.isIndex,
          onRightClick = _props.onRightClick;

      return _react2.default.createElement(
        _navBar2.default,
        {
          mode: 'dark',
          icon: isIndex ? '' : _react2.default.createElement(_icon2.default, { type: 'left', size: 'lg', className: 'zk_navbar-hd_margin' }),
          leftContent: isIndex ? '' : _react2.default.createElement(
            'div',
            { className: 'zk_navbar-hd_margin' },
            '\u8FD4\u56DE'
          ),
          onLeftClick: this.onLeftClick,
          rightContent: onRightClick ? _react2.default.createElement(_icon2.default, { key: '1', type: 'ellipsis', onClick: onRightClick }) : ''
        },
        title
      );
    }
  }]);
  return PageHead;
}(_react.Component);

/**
 * 页脚部分
 */


var PageFoot = function (_Component2) {
  (0, _inherits3.default)(PageFoot, _Component2);

  function PageFoot() {
    (0, _classCallCheck3.default)(this, PageFoot);
    return (0, _possibleConstructorReturn3.default)(this, (PageFoot.__proto__ || Object.getPrototypeOf(PageFoot)).apply(this, arguments));
  }

  (0, _createClass3.default)(PageFoot, [{
    key: 'render',
    value: function render() {
      return _react2.default.createElement(
        'div',
        null,
        this.props.foot
      );
    }
  }]);
  return PageFoot;
}(_react.Component);

/**
 * 页面布局
 */


var Page = function (_Component3) {
  (0, _inherits3.default)(Page, _Component3);

  function Page() {
    (0, _classCallCheck3.default)(this, Page);
    return (0, _possibleConstructorReturn3.default)(this, (Page.__proto__ || Object.getPrototypeOf(Page)).apply(this, arguments));
  }

  (0, _createClass3.default)(Page, [{
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          title = _props2.title,
          isIndex = _props2.isIndex,
          router = _props2.router,
          backLevel = _props2.backLevel,
          onRightClick = _props2.onRightClick,
          foot = _props2.foot,
          children = _props2.children,
          beforeBack = _props2.beforeBack,
          className = _props2.className;

      var pageClassName = className ? className + " zk_page-bd_bg" : "zk_page-bd_bg";
      return _react2.default.createElement(
        'div',
        { className: 'zk-page zk_div-animation' },
        title ? _react2.default.createElement(PageHead, {
          title: title,
          isIndex: isIndex,
          router: router,
          backLevel: backLevel,
          onRightClick: onRightClick,
          beforeBack: beforeBack
        }) : '',
        _react2.default.createElement(
          'div',
          { className: pageClassName },
          children
        ),
        _react2.default.createElement(PageFoot, { foot: foot })
      );
    }
  }]);
  return Page;
}(_react.Component);

Page.propTypes = {
  // 页面标题
  title: _propTypes2.default.string,
  // 是否是首页
  isIndex: _propTypes2.default.bool,
  // 导航栏右侧功能按钮点击事件
  onRightClick: _propTypes2.default.func,
  // 返回的层级
  backLevel: _propTypes2.default.number,
  // 样式类名称
  className: _propTypes2.default.string,
  // 底部内容
  foot: _propTypes2.default.element
};
exports.default = (0, _reactRouter.withRouter)(Page);
//# sourceMappingURL=Page.js.map