'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _echartsForReact = require('echarts-for-react');

var _echartsForReact2 = _interopRequireDefault(_echartsForReact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Pie = function (_Component) {
  (0, _inherits3.default)(Pie, _Component);

  function Pie(props) {
    (0, _classCallCheck3.default)(this, Pie);

    var _this = (0, _possibleConstructorReturn3.default)(this, (Pie.__proto__ || Object.getPrototypeOf(Pie)).call(this, props));

    _this.loading = null;
    _this.time = 3000;
    _this.radiusArr = [[0, '45%'], ['20%', '45%']];
    _this.radius = _this.radiusArr[0];
    _this.textColor = '#2983c7';
    _this.colors = ['#3fb1e3', '#6be6c1', '#626c91', '#a0a7e6', '#c4ebad', '#96dee8'];

    _this.onChartReady = function (chart) {
      _this.loading = setTimeout(function () {
        chart.hideLoading();
      }, _this.time);
      console.log('echarts is ready');
    };

    _this.getOption = function () {
      var _this$props = _this.props,
          data = _this$props.data,
          title = _this$props.title,
          labelFormatter = _this$props.labelFormatter;

      return {
        color: _this.colors,
        title: {
          text: title,
          x: 'center',
          textStyle: {
            color: _this.textColor,
            fontWeight: 'normal'
          }
        },
        tooltip: {
          trigger: 'item',
          formatter: "{a} <br/>{b} : {c} ({d}%)"
        },
        legend: {
          type: 'scroll',
          orient: 'vertical',
          top: 'middle',
          right: 'right',
          data: data.map(function (item) {
            return item.name;
          }),
          textStyle: { color: _this.textColor }
        },
        series: [{
          name: title,
          type: 'pie',
          radius: _this.radius,
          center: ['45%', '50%'],
          label: {
            normal: {
              formatter: labelFormatter
            }
          },
          selectedMode: 'single',
          data: data,
          itemStyle: {
            emphasis: {
              shadowBlur: 10,
              shadowOffsetX: 0,
              shadowColor: 'rgba(0, 0, 0, 0.5)'
            }
          }
        }]
      };
    };

    _this.getLoadingOption = function () {
      return {
        text: '加载中...',
        color: '#000',
        textColor: '#000',
        maskColor: '#fff'
      };
    };

    _this.handleData = function (data) {
      var body = '';
      if (data.length === 0) {
        body = _react2.default.createElement(
          'div',
          { className: 'zk_div-echars_nodata', style: { display: _this.state.display } },
          '\u65E0\u6570\u636E'
        );
      }
      return body;
    };

    var type = _this.props.type;

    if (type === '环形图') {
      _this.radius = _this.radiusArr[1];
    }
    _this.state = {
      showLoading: true
    };
    return _this;
  }

  (0, _createClass3.default)(Pie, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      clearTimeout(this.loading);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this.onChartReady(this.echarts_react.getEchartsInstance());
      this.setState({
        display: 'block',
        showLoading: false
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var data = this.props.data;

      var body = this.handleData(data);
      return _react2.default.createElement(
        'div',
        { style: { position: 'relative' } },
        _react2.default.createElement(_echartsForReact2.default, {
          ref: function ref(e) {
            _this2.echarts_react = e;
          },
          option: this.getOption(),
          loadingOption: this.getLoadingOption(),
          onChartReady: this.onChartReady,
          showLoading: this.state.showLoading,
          className: this.props.className
        }),
        body
      );
    }
  }]);
  return Pie;
}(_react.Component); /**
                      * 饼状图组件
                      */


Pie.propTypes = {
  // 数据
  data: _propTypes2.default.array.isRequired,
  // 标题
  title: _propTypes2.default.string,
  // 饼状图类型：'饼状图'|'环形图'
  type: _propTypes2.default.string,
  // 引导线上文本格式
  labelFormatter: _propTypes2.default.string,
  // 容器样式类
  className: _propTypes2.default.string
};
exports.default = Pie;
//# sourceMappingURL=Pie.js.map