'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toast = require('antd-mobile/lib/toast');

var _toast2 = _interopRequireDefault(_toast);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

require('antd-mobile/lib/toast/style/css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 *  轻提示方法，将antd-mobile中的Toast组件进行封装：
 *  自动关闭时间封装成2秒；
 *  关闭后无回调方法；
 *  使用场景：
 *  可以用来显示不会打断用户操作的内容，适合用于页面转场、数据交互的等场景中。
 */
var Toast = function () {
  function Toast() {
    (0, _classCallCheck3.default)(this, Toast);
    this.duration = 2;
  }

  (0, _createClass3.default)(Toast, null, [{
    key: 'success',


    /*
     * @function:成功提示
     * content:提示内容
     * */
    value: function success(content) {
      _toast2.default.success(content ? content : '操作成功', this.duration, null, false);
    }

    /*
     * @function:失败提示
     * content:提示内容
     * */

  }, {
    key: 'fail',
    value: function fail(content) {
      _toast2.default.fail(content ? content : '加载失败', this.duration, null, false);
    }

    /*
     * @function:信息提示
     * content:提示内容
     * */

  }, {
    key: 'info',
    value: function info(content) {
      _toast2.default.info(content, this.duration, null, false);
    }

    /*
     * @function:加载中提示
     * content:提示内容
     * mask:是否显示透明蒙层，防止触摸穿透
     * */

  }, {
    key: 'loading',
    value: function loading(content, mask) {
      _toast2.default.loading(content ? content : '加载中', 0, null, mask ? mask : false);
    }

    /*
     * @function: 网络失败提示
     * content:提示内容
     * */

  }, {
    key: 'offline',
    value: function offline(content) {
      _toast2.default.offline(content ? content : '网络异常，请检查网络环境', this.duration, null, false);
    }

    /*
     *@function:隐藏提示
     * */

  }, {
    key: 'hide',
    value: function hide() {
      _toast2.default.hide();
    }
  }]);
  return Toast;
}();

exports.default = Toast;
//# sourceMappingURL=Toast.js.map