/* card子项 */
import React, {Component} from 'react'
import PropTypes from 'prop-types'
import {InputItem} from 'antd-mobile';
import './CardItem.scss'

class CardItem extends Component {
  constructor(props) {
    super(props);
  }

  getAlignClass() {
    const {align} = this.props;
    switch (align) {
      case 'center':
        return 'zk_carditem_center';
      case 'justify':
        return 'zk_carditem_justify';
      default:
        return 'zk_carditem';
    }
  }

  getNewValue() {
    const {value, unit, unitPosition} = this.props;
    if (!unit || unit === '' || (!unitPosition || unitPosition === 'left')) {
      return value;
    }
    if (!unitPosition || unitPosition === 'right') {
      return `${value}${unit}`;
    }
  }

  getNewLabel() {
    const {label, unit, unitPosition} = this.props;
    if (!unit || unit === '' || (!unitPosition || unitPosition === 'right')) {
      return label;
    }
    if (!unitPosition || unitPosition === 'left') {
      return <span>{label}<span className={'zk_carditem-uint'}>（{unit}）</span></span>;
    }
  }

  render() {
    const {label} = this.props;
    let newLabel = this.getNewLabel();
    let newValue = this.getNewValue();
    return (
      <InputItem
        {...this.props}
        labelNumber={7}
        key={label}
        className={this.getAlignClass()}
        value={newValue}
        editable={false}
      >
        {newLabel}
      </InputItem>
    );
  }
}

CardItem.propTypes = {
  label: PropTypes.string,
  value: PropTypes.oneOfType([PropTypes.element, PropTypes.string]),
  align: PropTypes.string,
  unit: PropTypes.string,
  unitPosition: PropTypes.string
};

export default CardItem
