import React, {Component} from 'react'
import PropTypes from 'prop-types'
import {Button, InputItem, List, WhiteSpace, WingBlank} from 'antd-mobile';
import {DefaultLoginIcon} from './styles/Icon'
import './styles/LoginForm.css'

class LoginForm extends Component {

  handleVal = () => {
    this.props.submit(this.refs.name.state.value, this.refs.pwd.state.value);
  };

  render() {
    const containerHeight = document.documentElement.clientHeight;
    return (
      <div style={{height: containerHeight}} className='zk_loginform_bg'>
        <div className='zk-loginform-hd'>
          <img src={this.props.logo || DefaultLoginIcon}/>
          <div className='zk_title_b zk_color'>{this.props.title}</div>
        </div>
        <WingBlank>
          <WhiteSpace size="xl"/>
          <WhiteSpace size="xl"/>
          <WhiteSpace size="xl"/>
          <List>
            <InputItem
              placeholder="请输入登录名"
              clear="true" ref="name"
            >登录名</InputItem>
            <InputItem
              type="password" ref="pwd" clear="true"
              placeholder="请输入密码"
            >密码</InputItem>
          </List>
          <WhiteSpace size="xl"/>
          <div style={{textAlign: "center"}}>
            {this.props.errorTip}
          </div>
          <WhiteSpace size="xl"/>
          <WhiteSpace size="xl"/>
          <Button type="primary" onClick={this.handleVal}>登录</Button>
        </WingBlank>
      </div>
    )
  }
}

LoginForm.propTypes = {
  title: PropTypes.string.isRequired,
  login: PropTypes.func
};

export default LoginForm;
